"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const general_1 = require("../../helpers/general");
function Bind(target, propertyKey, descriptor) {
    if (!descriptor || !general_1.isFunction(descriptor.value)) {
        throw `Only put a @Bind decorator on a method or get accessor.`;
    }
    return {
        configurable: true,
        get() {
            const withBind = descriptor.value.bind(this);
            Object.defineProperty(this, propertyKey, {
                configurable: true,
                writable: true,
                value: withBind,
            });
            return withBind;
        },
    };
}
exports.Bind = Bind;
//# sourceMappingURL=bind.js.map